package com.jiuqi.grid;

import java.util.Iterator;
import java.util.Map;
import com.jiuqi.util.Stream;
import com.jiuqi.util.StreamException;
import com.jiuqi.util.MemStream;
import java.util.Hashtable;
import java.io.Serializable;

public class ExtendedDatas implements Serializable, Cloneable
{
    private Hashtable extDatas;
    
    public ExtendedDatas() {
        this.extDatas = new Hashtable();
    }
    
    public byte[] getData(final String name) {
        return this.extDatas.get(name);
    }
    
    public void setData(final String name, final byte[] data) {
        if (data == null || data.length == 0) {
            this.extDatas.remove(name);
        }
        else {
            this.extDatas.put(name, data);
        }
    }
    
    public void setData(final String name, final int[] data) {
        if (data == null || data.length == 0) {
            this.extDatas.remove(name);
        }
        else {
            final MemStream stream = new MemStream();
            try {
                for (int i = 0; i < data.length; ++i) {
                    stream.writeInt(data[i]);
                }
                this.setData(name, stream.getBytes());
            }
            catch (final StreamException e) {
                e.printStackTrace();
            }
        }
    }
    
    public void clear() {
        this.extDatas.clear();
    }
    
    public boolean contains(final String name) {
        return this.extDatas.containsKey(name);
    }
    
    public void loadFromStream(final Stream stream, final int size) throws StreamException {
        this.clear();
        while (stream.getPosition() < size) {
            int len = stream.readInt();
            final String key = stream.readString(len);
            len = stream.readInt();
            final byte[] data = new byte[len];
            stream.readBuffer(data, 0, len);
            this.extDatas.put(key, data);
        }
    }
    
    public void saveToStream(final Stream stream) throws StreamException {
        for (final Map.Entry item : this.extDatas.entrySet()) {
            final String key = item.getKey();
            stream.writeInt(key.length());
            stream.writeString(key);
            final byte[] data = item.getValue();
            stream.writeInt(data.length);
            stream.writeBuffer(data, 0, data.length);
        }
    }
    
    @Override
    protected Object clone() {
        try {
            final ExtendedDatas result = (ExtendedDatas)super.clone();
            result.extDatas = new Hashtable(this.extDatas);
            return result;
        }
        catch (final CloneNotSupportedException ex) {
            return null;
        }
    }
}
